%define _stripped_files_terminate_build 1

Name:           opentoonz
Version:        1.7.1
Release:        %mkrel 5
Summary:        Full-featured 2D animation creation software
License:        BSD-2-Clause
Group:          Graphics/Utilities
URL:            https://opentoonz.github.io/e/
Source0:        https://github.com/opentoonz/opentoonz/archive/v%{version}/%{name}-%{version}.tar.xz
# PATCH-FIX-UPSTREAM
Patch0:         0001-Fix-linker-errors-on-Linux.patch
# PATCH-FIX-UPSTREAM
Patch1:         0001-Fix-build-with-Werror-return-type.patch

Patch10:        opentoonz-1.7.0-install-path-fix.patch
Patch11:        opentoonz-1.7.1-funcptr-fix.patch
Patch12:        opentoonz-cmake-4.0.patch

# build fails on ARM (conflicting declaration between glew and gles)
ExclusiveArch:  %{ix86} x86_64 aarch64

BuildRequires:  cmake
BuildRequires:  boost-devel
BuildRequires:  openblas-devel
# needed to setup startup script paths
BuildRequires:  sed
BuildRequires:  cmake(OpenCV)
BuildRequires:  cmake(Qt5Core)
BuildRequires:  cmake(Qt5Gui)
BuildRequires:  cmake(Qt5LinguistTools)
BuildRequires:  cmake(Qt5Multimedia)
BuildRequires:  cmake(Qt5MultimediaWidgets)
BuildRequires:  cmake(Qt5Network)
BuildRequires:  cmake(Qt5OpenGL)
BuildRequires:  cmake(Qt5PrintSupport)
BuildRequires:  cmake(Qt5Script)
BuildRequires:  cmake(Qt5SerialPort)
BuildRequires:  cmake(Qt5Svg)
BuildRequires:  cmake(Qt5UiTools)
BuildRequires:  cmake(Qt5Widgets)
BuildRequires:  cmake(Qt5Xml)
BuildRequires:  pkgconfig(freeglut)
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(glew)
BuildRequires:  pkgconfig(libjpeg)
BuildRequires:  pkgconfig(liblz4)
BuildRequires:  pkgconfig(liblzma)
BuildRequires:  pkgconfig(libmypaint)
BuildRequires:  pkgconfig(libpng)
BuildRequires:  pkgconfig(libusb-1.0)
BuildRequires:  pkgconfig(libtiff-4)
BuildRequires:  pkgconfig(lzo2)
BuildRequires:  pkgconfig(mypaint-brushes-2.0)
BuildRequires:  pkgconfig(sdl2)
BuildRequires:  pkgconfig(superlu)
BuildRequires:  pkgconfig(zlib)

%description
OpenToonz is a 2D animation software previously known as Toonz.

%prep
%autosetup -p1

%build
# NOTE: Third party dependencies are dropped from the tarball thanks to the
# _service file. Only kissfft130, lzo/driver and tiff-4.0.3 shall be kept.

# Build patched libtiff
# TODO upstream planning to replace custom thirdparty libs with system versions
cd thirdparty/tiff-*
export CFLAGS="%{optflags} -fPIC"
%configure --disable-jbig
%make_build
cd -

# Build opentoonz
pushd toonz/sources
%cmake \
  -DCMAKE_SKIP_RPATH:BOOL=ON \
  -DWITH_SYSTEM_LZO:BOOL=ON \
  -DWITH_SYSTEM_SUPERLU:BOOL=ON \
  -DWITH_TRANSLATION:BOOL=OFF

%cmake_build
popd

# Build opentoonz plugins
for i in plugins/{blur,geom,multiplugin} ; do
pushd $i
%cmake
%cmake_build
popd
done

%install
# install opentoonz
pushd toonz/sources
%cmake_install
popd

# install opentoonz plugins
for i in plugins/{blur,geom,multiplugin} ; do
pushd $i
install %{_vpath_builddir}/*.plugin %{buildroot}%{_datadir}/%{name}/stuff/plugins/
popd
done

%files
%doc README.md
%license LICENSE.txt
%{_bindir}/lzocompress
%{_bindir}/lzodecompress
%{_bindir}/OpenToonz
%{_bindir}/opentoonz
%{_bindir}/tcleanup
%{_bindir}/tcomposer
%{_bindir}/tconverter
%{_bindir}/tfarmcontroller
%{_bindir}/tfarmserver
%{_datadir}/applications/io.github.OpenToonz.desktop
%{_iconsdir}/hicolor/*/apps/io.github.OpenToonz.png
%{_datadir}/metainfo/io.github.OpenToonz.appdata.xml
%{_datadir}/opentoonz/
%{_libdir}/opentoonz/


%changelog
* Thu Jul 03 2025 daviddavid <daviddavid> 1.7.1-5.mga10
+ Revision: 2244566
- Mageia 10 Mass Rebuild
- fix build with cmake 4.0

* Thu May 22 2025 daviddavid <daviddavid> 1.7.1-4.mga10
+ Revision: 2185581
- add fedora patch to fix build with gcc 15

* Sat Sep 14 2024 wally <wally> 1.7.1-3.mga10
+ Revision: 2096250
- rebuild for opencv 4.10.0
+ daviddavid <daviddavid>
- rebuild for new superlu 7.0.0

* Sat Feb 17 2024 daviddavid <daviddavid> 1.7.1-1.mga10
+ Revision: 2042203
- initial package opentoonz (mga#24416)

